#include "sendrecvmsg.h"
//gestisce l'emissione del messaggio
//ritorna:
// 0 se la fase e' stata compiuta con successo
//-1 se ci sono errori o scade il timeout
int SendMsg(SOCKDESCR sock, string msg)
{
	char buffer[TOKEN];
	memset(&buffer,0,TOKEN);
	if(msg.size() >= TOKEN-1){
		cerr<<"SendMsg: errore il messaggio e'+ lungo del buffer."<<endl;
		return -1;
	}
	strcpy(buffer,msg.c_str());
	int bytesent = 0;
	bytesent = Send(sock,(void *)buffer,TOKEN,0,SENDMSG_TIMEOUT);
	if(bytesent == -1){
		cout<<"Timeout o errori irreversibili nella send. Aborting send"<<endl;
		return -1;
	} else if(bytesent != TOKEN){
			cout<<"errori irrecuperabili durante la trasmissione. Aborting"<<endl;
			return -1;
		}
	//messaggio spedito con successo
	return 0;
}
//-----------------------------------------------------------
//riceve un messagio e lo converte in stringa
//ritorn:
// 0 se tutto OK
//-1 se il messaggio e' corrotto o scade il timeout 
int RecvMsg(SOCKDESCR sock, string &msg)
{
	char buffer[TOKEN];
	memset(buffer,0,TOKEN);
	int byterecv = 0;
	byterecv = Recv(sock,buffer,TOKEN,0,RECVMSG_TIMEOUT);
	switch(byterecv){
		case TOKEN:{
			msg = buffer;
			return 0;
		}break;
		case -1:{
			cout<<"received timeouted. Aborting"<<endl;
			return -1;
		}break;
		case -2:{
			cerr<<"Unrecoverable RecvMsg error"<<endl;
			return -1;
		}break;
		default:{
			cerr<<"Ricevuto un messagio corrotto (wrong length)"<<endl;
			return -1;
		}
	}
}
//-------------------------------------------------------